<?php
/**
 * Pimcore
 *
 * This source file is available under two different licenses:
 * - GNU General Public License version 3 (GPLv3)
 * - Pimcore Enterprise License (PEL)
 * Full copyright and license information is available in
 * LICENSE.md which is distributed with this source code.
 *
 * @package    AuditBundle
 *
 * @copyright  Copyright (c) Pimcore GmbH (http://www.pimcore.org)
 * @license    http://www.pimcore.org/license     GPLv3 and PEL
 */

namespace AuditBundle\Model\Asset\AssetAudit;

use Pimcore\Model;

/**
 * @method \AuditBundle\Model\Asset\AssetAudit\Listing\Dao getDao()
 * @method Model\Asset\AssetAudit[] load()
 */
class Listing extends Model\Listing\AbstractListing implements \Zend\Paginator\Adapter\AdapterInterface
{
    /**
     * Contains the results of the list.
     *
     * @var array
     */
    public $assetAudits = [];

    /**
     * Tests if the given key is an valid order key to sort the results
     *
     * @param $key
     *
     * @return bool
     */
    public function isValidOrderKey($key)
    {
        return true;
    }

    /**
     * Getter for assetAudits.
     *
     * @return array
     */
    public function getAssetAudits()
    {
        return $this->assetAudits;
    }

    /**
     * setter for assetAudits.
     *
     * @param array $assetAudits
     *
     * @return $this
     */
    public function setAssetAudits($assetAudits)
    {
        $this->assetAudits = $assetAudits;

        return $this;
    }

    /**
     *
     * Method for \Zend_Paginator_Adapter_Interface | AdapterInterface
     *
     * @return int
     */
    public function count()
    {
        return $this->getTotalCount();
    }

    /**
     * Methods for \Zend_Paginator_Adapter_Interface | AdapterInterface
     *
     * @param int $offset
     * @param int $itemCountPerPage
     *
     * @return array
     */
    public function getItems($offset, $itemCountPerPage)
    {
        $this->setOffset($offset);
        $this->setLimit($itemCountPerPage);

        return $this->load();
    }
}
